////////////////////////////////////////////////////////////
// standard header for pre-compile
//
// Written by Manuke

////////////////////////////////////////////////////////////
// platform & compiler

#ifdef _MSC_VER // Win32 platform & Visual C++

// delete unused inline function
#pragma warning(disable : 4514)
// unreferenced inline/local function has been removed
#pragma warning(disable : 4710)
// old-type function
#pragma warning(disable : 4996)

#define Z80S1_PLATFORM_WINDOWS
#define Z80S1_COMPILER_TEMPLATE_EXPLICIT_SUPPORT
#define Z80S1_COMPILER_TEMPLATE_STATICVAL_NORMAL
#define Z80S1_BYTEORDER_LITTLE_ENDIAN

#elif defined(__BORLANDC__) // Win32 platform & Borland C++

// unreferenced inline/local function has been removed
#pragma warning(disable : 4710)

#define Z80S1_PLATFORM_WINDOWS
#define Z80S1_COMPILER_TEMPLATE_EXPLICIT_SUPPORT
#define Z80S1_COMPILER_TEMPLATE_STATICVAL_NORMAL
#define Z80S1_BYTEORDER_LITTLE_ENDIAN

#else // GNU/Linux platform & g++

#define Z80S1_PLATFORM_UNIX
#define Z80S1_COMPILER_TEMPLATE_EXPLICIT_SUPPORT
#define Z80S1COMPILER_TEMPLATE_STATICVAL_SPECIAL

#endif // Platform

////////////////////////////////////////////////////////////
// include

#ifdef Z80S1_PLATFORM_WINDOWS

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

typedef signed char int8_t;
typedef unsigned char uint8_t;
typedef signed short int16_t;
typedef unsigned short uint16_t;
typedef signed long int32_t;
typedef unsigned long uint32_t;

#elif defined(Z80S1_PLATFORM_UNIX)

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>

#ifndef __CYGWIN__
#include <endian.h>
#else // __CYGWIN__
#include <sys/param.h>
#endif // __CYGWIN__

#if defined(BYTE_ORDER) && defined(LITTLE_ENDIAN)
#if BYTE_ORDER == LITTLE_ENDIAN
#define Z80S1_BYTEORDER_LITTLE_ENDIAN
#else // BYTE_ORDER != LITTLE_ENDIAN
#define Z80S1_BYTEORDER_BIG_ENDIAN
#endif // BYTE_ORDER
#else // !defined(BYTE_ORDER) || !defined(LITTLE_ENDIAN)
#define Z80S1_BYTEORDER_LITTLE_ENDIAN
#endif // defined(BYTE_ORDER) && defined(LITTLE_ENDIAN)

#endif // Z80S1PLATFORM
